import java.lang.*;
import java.io.*;

public class Bank {
	static byte pk[];
	static int size, datasize;
	static int start, idx, oidx;
	static int crc, chk;
	
	static int int32(int adr) {
		return	((pk[adr]) << 24) |
			((pk[adr + 1] & 0xFF) << 16) |
			((pk[adr + 2] & 0xFF) << 8) |
			(pk[adr + 3] & 0xFF);
	}
	
	static boolean rcr(boolean cf) {
		boolean rcf = ((chk & 1) != 0);
		chk >>>= 1;
		if(cf)
			chk |= 0x80000000;
		return rcf;
	}
	
	static boolean nextChunk() {
		boolean cf = rcr(false);
		if(chk == 0) {
			chk = int32(idx);
			idx -= 4;
			crc ^= chk;
			cf = rcr(true);
		}
		return cf;
	}
	
	static int getCode(int numChunks) {
		int c = 0;
		while((numChunks--) != 0) {
			c <<= 1;
			if(nextChunk())
				c |= 1;
		}
		return c;
	}
	
	static void decUnk1(int numChunks, int addCount) {
		int count = getCode(numChunks) + addCount + 1;
		datasize -= count;
		while((count--) != 0) {
			pk[oidx] = (byte) getCode(8);
			--oidx;
		}
	}

	static void decUnk2(int numChunks) {
		int i = getCode(numChunks);
		int count = size + 1;
		datasize -= count;
		while((count--) != 0) {
			pk[oidx] = pk[oidx + i];
			--oidx;
		}
	}

	static boolean unpack() {
		size = 0;
		datasize = int32(idx);
		idx -= 4;
		oidx = start + datasize - 1;
		crc = int32(idx);
		idx -= 4;
		chk = int32(idx);
		idx -= 4;
		crc ^= chk;
		
		do {
			if(!nextChunk()) {
				size = 1;
				if(!nextChunk())
					decUnk1(3, 0);
				else
					decUnk2(8);
			} else {
				int c = getCode(2);
				if(c == 3) {
					decUnk1(8, 8);
				} else {
					if(c < 2) {
						size = c + 2;
						decUnk2(c + 9);
					} else {
						size = getCode(8);
						decUnk2(12);
					}
				}
			}
		} while(datasize > 0);
		
		return crc == 0;
	}

	public static boolean load(MemRecord rec) {
		InputStream is = Midlet.self.getClass().getResourceAsStream("/ANWORLD/BANK0"+Integer.toHexString(rec.bank).toUpperCase());
		DataInputStream dis = new DataInputStream(is);
		
		System.out.println("Size: "+rec.size);
		pk = new byte[rec.size];
		
		try {
		dis.skip(rec.offset);
		dis.read(pk, 0, rec.pkgsize);
		dis.close();
		} catch(IOException e) {}
		
		boolean stat;
		if(rec.pkgsize == rec.size) {
			System.out.println("UnPacked data!");
			stat = true;
		} else {
			System.out.println("Packed data!");
			start = 0;
			idx = start + rec.pkgsize - 4;
			stat = unpack();
		}
		
		if(stat)
			rec.data = pk;
		
		pk = null;
		return stat;
	}
}