import java.lang.*;
import java.io.*;

public class Memlist {
	public static final int STATE_NOP = 0x00;
	public static final int STATE_END = 0xFF;
	
	public static final int TYPE_SOUND = 0x0;
	public static final int TYPE_MUSIC = 0x1;
	public static final int TYPE_ANIM = 0x2;
	public static final int TYPE_PAL = 0x3;
	public static final int TYPE_CODE = 0x4;
	public static final int TYPE_CINEMA = 0x5;

	public static final int DEFLEN = 150;
		
	public static MemRecord[] load(String path) {
		InputStream is = Midlet.self.getClass().getResourceAsStream(path);
		DataInputStream dis = new DataInputStream(is);
		
		MemRecord tmp[] = new MemRecord[DEFLEN];
		
		int i = 0;
		do {
			tmp[i] = new MemRecord();
			
			try {
			tmp[i].state = dis.readUnsignedByte();
			tmp[i].type = dis.readUnsignedByte();
			dis.skipBytes(5);
			tmp[i].bank = dis.readUnsignedByte();
			tmp[i].offset = dis.readInt();
			dis.skipBytes(2);
			tmp[i].pkgsize = dis.readUnsignedShort();
			dis.skipBytes(2);
			tmp[i].size = dis.readUnsignedShort();
			} catch(IOException e) {
				e.printStackTrace();
			}
			
			/*System.out.println("========= "+i+" =========");
			System.out.println("state = "+tmp[i].state);
			System.out.println("type = "+tmp[i].type);*/
			/*System.out.println("bank = "+tmp[i].bank);
			System.out.println("offset = "+tmp[i].offset);
			System.out.println("pkgsize = "+tmp[i].pkgsize);
			System.out.println("size = "+tmp[i].size);*/
		} while(tmp[i++].state != STATE_END);
		
		try {
		dis.close();
		} catch(IOException e) {}
		return tmp;
	}
}