public class VM {
	public static MemRecord[] rec;

	static final int NUM_REGS = 256;
	static final int NUM_THRS = 64;
	
	static final int REG_RAND = 0x3C;
	static final int REG_SCROLL = 0xF9;
	static final int REG_PAUSE = 0xFF;
	
	static short reg[] = new short[NUM_REGS];
	static short pc[] = new short[NUM_THRS];
	static short sp[] = new short[NUM_THRS];
	static short stack[][] = new short[NUM_THRS][256];
	static boolean paused[] = new boolean[NUM_THRS];
	static byte vid1[], vid2[];
	static byte code[];
	static byte palete[];
	
	static boolean usevid2;
	static byte viddata[];
	static int vidpc;
	
	static int thr, currentpart;
	
	static boolean nextpc;
	
	static int opadr;
	
	static long lasttime = System.currentTimeMillis();
	
	static int ubyte() {
		return code[pc[thr]++] & 0xFF;
	}
	
	static int ushort() {
		return (ubyte() << 8) | ubyte();
	}
	
	static int vbyte() {
		return viddata[vidpc++] & 0xFF;
	}
	
	static int vshort() {
		return (vbyte() << 8) | vbyte();
	}
	
	static void println(String s) {
		System.out.println("<"+opadr+"> THR"+thr+" : "+s);
	}
	
	static void readpoly(int color, int zoom, int x, int y) {
		int t = vbyte();
		
		System.out.println("readpoly t = "+t);
		if(t >= 0xC0) {
			if((color & 0x80) != 0)
				color = t & 0x3F;
			
			Polygon p = new Polygon();
			p.w = vbyte() * zoom / 64;
			p.h = vbyte() * zoom / 64;
			p.num = vbyte();
			
			p.pointx = new int[p.num];
			p.pointy = new int[p.num];
			
			for(int i = 0; i < p.num; i++) {
				p.pointx[i] = vbyte() * zoom / 64;
				p.pointy[i] = vbyte() * zoom / 64;
			}
			
			Video.DrawPolygon(color, zoom, x, y, p);
		} else {
			t &= 0x3F;
			if(t == 1) {
				System.out.println("warn1");
			} else if(t == 2) {
				int xx = x - vbyte() * zoom / 64;
				int yy = y - vbyte() * zoom / 64;
				
				int childs = vbyte();
				System.out.println("group "+childs+" "+xx+" "+yy);
				for(; childs >= 0; --childs) {
					int off = vshort();
					int xxx = xx + vbyte() * zoom / 64;
					int yyy = yy + vbyte() * zoom / 64;
					
					int c = 0xFF;
					int bp = off;
					off &= 0x7FFF;
					
					if((bp & 0x8000) != 0) {
						System.out.println("read color");
						c = vshort() & 0x7F;
					}
					
					int bak = vidpc;
					vidpc = off * 2;
					
					System.out.println("  poly ("+vidpc+") "+color+" x"+xxx+" y"+yyy);
					readpoly(c, zoom, xxx, yyy);
					vidpc = bak;
				}
			} else {
				System.out.println("warn2");
				//for(;;);
			}
		}
	}
	
	static void thread() {	
		opadr = pc[thr];
		int opcode = ubyte();
		
		if((opcode & 0x80) != 0) {
			int off = ((opcode << 8) | ubyte()) * 2;
			int x = ubyte();
			int y = ubyte();
			int h = y - 199;
			if(h > 0) {
				y = 199;
				x += h;
			}
			
			usevid2 = false;
			
			viddata = vid1;
			vidpc = off & 0x7FFF;
			
			println("DRAW1 "+opcode+" "+vidpc+" "+x+" "+y);	
			readpoly(0xFF, 0x40, x, y);
			
			return;
		}
		
		if((opcode & 0x40) != 0) {
			int off = ushort() * 2;
			
			usevid2 = false;
			
			int x = ubyte();
			if((opcode & 0x20) == 0) {
				if((opcode & 0x10) == 0)
					x = (x << 8) | ubyte();
				else
					x = reg[x];
			} else {
				if((opcode & 0x10) != 0)
					x += 0x100;
			}
			
			int y = ubyte();
			if((opcode & 0x8) == 0) {
				if((opcode & 0x4) == 0)
					y = (y << 8) | ubyte();
				else
					y = reg[y];
			}
			
			int zoom = ubyte();
			if((opcode & 0x2) == 0) {
				if((opcode & 0x1) == 0) {
					--pc[thr];
					zoom = 0x40;
				} else {
					zoom = reg[zoom];
				}
			} else {
				if((opcode & 0x1) != 0) {
					usevid2 = true;
					--pc[thr];
					zoom = 0x40;
				}
			}
			
			viddata = (usevid2)?vid2:vid1;
			println("usevid2 = "+usevid2);
			vidpc = off & 0x7FFF;
			
			println("DRAW2 "+opcode+" "+vidpc+" "+x+" "+y);
			readpoly(0xFF, 0x40, x, y);
			
			
			return;
		}
		
		
		int x, y, z, w;
		boolean cond;
		
		switch(opcode) {
		case 0x00: //MOV CONST
			x = ubyte();
			y = ushort();
			reg[x] = (short) y;
			println("MOV CONST R"+x+" #"+y);
			break;
		case 0x01: //MOV
			x = ubyte();
			y = ubyte();
			reg[x] = reg[y];
			println("MOV R"+x+" R"+y);
			break;
		case 0x02: //ADD
			x = ubyte();
			y = ubyte();
			reg[x] += reg[y];
			println("ADD R"+x+" R"+y);
			break;
		case 0x03: //ADD CONST
			x = ubyte();
			y = ushort();
			reg[x] += (short) y;
			println("ADD CONST R"+x+" #"+y);
			break;
		case 0x04: //CALL
			x = ushort();
			stack[thr][sp[thr]++] = pc[thr];
			pc[thr] = (short) x;
			println("CALL @"+x);
			break;
		case 0x05: //RET
			pc[thr] = stack[thr][--sp[thr]];
			println("RET @"+pc[thr]);
			break;
		case 0x06: //NEXT THREAD
			nextpc = true;
			println("NEXTTHR");
			break;
		case 0x07: //JMP
			pc[thr] = (short) ushort();
			println("JMP #"+pc[thr]);
			break;
		case 0x08: //SETVEC
			x = ubyte();
			y = ushort();
			pc[x] = (short)y;
			println("SETVEC THR"+x+" @"+y);
			break;
		case 0x09: //JNZC
			x = ubyte();
			y = ushort();
			
			--reg[x];
			if(reg[x] != 0)
				pc[thr] = (short) y;
			println("JNZC "+x+" "+y);
			break;
		case 0x0A: //COND JMP
			w = ubyte(); //opcode
			x = reg[ubyte()];
			y = 0;

			if((w & 0x80) != 0)
				y = reg[ubyte()];
			else if((w & 0x40) != 0)
				y = (short) ushort();
			else
				y = (byte) ubyte();
			
			String opname;
			switch(w & 0x7) {
			case 0: //JZ
				cond = (x == y);
				opname = "JZ";
				break;
			case 1: //JNZ
				cond = (x != y);
				opname = "JNZ";
				break;
			case 2: //JG
				cond = (x > y);
				opname = "JG";
				break;
			case 3: //JGE
				cond = (x >= y);
				opname = "JGE";
				break;
			case 4: //JL
				cond = (x < y);
				opname = "JL";
				break;
			case 5: //JLE
				cond = (x <= y);
				opname = "JLE";
				break;
			default:
				cond = false;
				opname = "UNK_COND_JUMP";
			}
			
			z = ushort();
			if(cond)
				pc[thr] = (short) z;
			
			println(opname+" "+w+" "+x+" "+y+" "+z);
			break;
		case 0x0B: //SETPAL
			x = ushort() >>> 8;
			Video.SetPalette(x, palete);
			println("SETPAL "+x);
			break;
		case 0x0C: //RESET THR
			x = ubyte();
			y = ubyte();
			z = (y & 0x3F) - x;
			opname = "RESETTHR "+x+" "+y;
			if(z < 0) {
				println(opname);
				break;
			}
			++z;
			
			w = ubyte();
			if(w == 2) {
				while((z--) != 0)
					pc[x++] = (short) 0xFFFE;
			} else if(w < 2) { //FIXIT
				while((z--) != 0)
					paused[x++] = (w != 0)?true:false;
			}
			println(opname+" "+w);
			break;
		case 0x0D: //SET VIDEO PAGE
			x = ubyte();
			Video.SetPage(x);
			println("SETVID "+x);
			break;
		case 0x0E: //FILL VIDEO PAGE
			x = ubyte();
			y = ubyte();
			Video.ClearPage(x, y);
			println("CLR "+x+" "+y);
			break;
		case 0x0F: //COPY VIDEO PAGE
			x = ubyte();
			y = ubyte();
			Video.CopyPage(x, y, reg[REG_SCROLL]);
			println("COPY "+x+" "+y);
			break;
		case 0x10: //BLIT FRAMEBUFFER
			x = ubyte();
			reg[0xF7] = 0;
			
			Video.ShowPage(x, reg[REG_PAUSE] * 20);
			println("SHOW "+x);
			break;
		case 0x11: //KILL THREAD
			pc[thr] = (short) 0xFFFF;
			nextpc = true;
			println("KILLTHR");
			break;
		case 0x12: //DRAW STRING
			z = ushort(); //strid
			x = ubyte();
			y = ubyte();
			w = ubyte(); //color
			Video.DrawString(""+z, x, y, w);
			println("DRAWSTR "+z+" "+x+" "+y+" "+w);
			break;
		case 0x13: //SUB
			x = ubyte();
			y = ubyte();
			reg[x] -= reg[y];
			println("SUB R"+x+" R"+y);
			break;
		case 0x14: //AND
			x = ubyte();
			y = ushort();
			reg[x] &= (short) y;
			println("AND R"+x+" #"+y);
			break;
		case 0x15: //OR
			x = ubyte();
			y = ushort();
			reg[x] |= (short) y;
			println("OR R"+x+" #"+y);
			break;
		case 0x16: //SHL
			x = ubyte();
			y = ushort();
			reg[x] <<= (short) y;
			println("SHL R"+x+" #"+y);
			break;
		case 0x17: //SHR
			x = ubyte();
			y = ushort();
			reg[x] >>>= (short) y;
			println("SHR R"+x+" #"+y);
			break;
		case 0x18: //PLAY SOUND
			x = ushort(); //resource id
			y = ubyte(); //freq
			z = ubyte(); //vol
			w = ubyte(); //channel
			println("PLAYSND "+x+" "+y+" "+z+" "+w);
			break;
		case 0x19: //UPD MEMLIST
			x = ushort();
			println("UPDMEMLIST "+x);
			break;
		case 0x1A: //PLAY MUSIC
			x = ushort(); //resource id
			y = ushort(); //delay
			z = ubyte(); //pos
			println("PLAYMUS "+x+" "+y+" "+z);
			break;
		default:
			println("Invalid opcode "+opcode);
		}
	}
	
	public static void setpart(int part) {
		if(part == currentpart)
			return;
		
		palete = rec[Game.partlist[part - Game.PART_FIRST][Game.PART_PAL]].data;
		code = rec[Game.partlist[part - Game.PART_FIRST][Game.PART_CODE]].data;
		vid1 = rec[Game.partlist[part - Game.PART_FIRST][Game.PART_VID1]].data;
		vid2 = rec[Game.partlist[part - Game.PART_FIRST][Game.PART_VID2]].data;
	}
		
	public static void cycle() {
		reg[0xE4] = 20;
		reg[0x54] = 0x81;
		reg[REG_RAND] = (short) System.currentTimeMillis();
		for(int i = 0; i < NUM_THRS; i++) {
			pc[i] = (short) 0xFFFF;
			paused[i] = false;
		}
		thr = 0;
		pc[thr] = 0;
		
		while(true) {
			for(thr = 0; thr < NUM_THRS; thr++) {
				if(paused[thr])
					continue;
			
				if((pc[thr] & 0xFFFF) == 0xFFFF)
					continue;
				
				nextpc = false;
				while(!nextpc)
					thread();
			}
		}
	}
}