import java.lang.*;
import javax.microedition.lcdui.*;

public class Video extends Canvas {
	public static Canvas self;
	
	static int pal[] = new int[16];
	
	static int paintPage = 2, tmpPage = 1;
	static int currentPage = GetPage(0xFE);
	
	static Page page[] = new Page[4];
	
	public Video() {
		for(int i = 0; i < 4; i++)
			page[i] = new Page();
	}
	
	protected void paint(Graphics g) {
		Page p = page[paintPage];
		g.setColor(0xFFFFFF);
		g.fillRect(0, 0, 400, 400);
		g.drawRGB(p.buf, 0, p.w, 0, 0, p.w, p.h, false);
		g.drawString("PAGE "+paintPage, 0, 0, 0);
		
		p = page[0];
		g.drawRGB(p.buf, 0, p.w, 320, 0, p.w, p.h, false);
		g.drawString("PAGE "+0, 320, 0, 0);
		
		p = page[1];
		g.drawRGB(p.buf, 0, p.w, 0, 200, p.w, p.h, false);
		g.drawString("PAGE "+1, 0, 200, 0);
		
		p = page[2];
		g.drawRGB(p.buf, 0, p.w, 320, 200, p.w, p.h, false);
		g.drawString("PAGE "+2, 320, 200, 0);
		
		p = page[3];
		g.drawRGB(p.buf, 0, p.w, 0, 400, p.w, p.h, false);
		g.drawString("PAGE "+3, 0, 400, 0);
	}
	
	public static void Repaint() {
		self.repaint();
		self.serviceRepaints();
	}
	
	public static int GetPage(int i) {
		switch(i) {
		case 0xFF: //Page that not painted now
			return (paintPage == 1)?2:1;
		case 0xFE: //Current painted page
			return paintPage;
		default:
			return i;
		}
	}
	
	public static void SetPalette(int num, byte data[]) {
		if(num >= 32)
			return;
		
		int off = num * 32;
		
		for(int i = 0; i < 16; i++) {
			int c1 = data[off] & 0xFF;
			int c2 = data[off + 1] & 0xFF;
			off += 2;
			
			int r = ((c1 & 0x0F) << 2) | ((c1 & 0x0F) >> 2) ; // r
			int g = ((c2 & 0xF0) >> 2) | ((c2 & 0xF0) >> 6); // g
			int b = ((c2 & 0x0F) >> 2) | ((c2 & 0x0F) << 2); // b
			
			r <<= 2;
			g <<= 2;
			b <<= 2;
			
			pal[i] = (i << 24) | (r << 16) | (g << 8) | (b);
			System.err.println("PAL["+i+"] = "+r+" "+g+" "+b+"("+((c1<<8)|c2)+")");
		}
	}
	
	public static void SetPage(int i) {
		currentPage = GetPage(i);
	}
	
	public static void ClearPage(int idx, int color) {
		idx = GetPage(idx);
		Page p = page[idx];
		/*Graphics g = page[idx].g;
		Image img = page[idx].img;
		
		g.setColor(pal[color]);
		g.fillRect(0, 0, img.getWidth(), img.getHeight()); */
		
		color = (color << 24) | pal[color];
		for(int i = 0; i < page[idx].buf.length; i++)
			page[idx].buf[i] = color;
	}
	
	public static void CopyPage(int src, int dst, int vscroll) {
		if(src >= 0xFE || ((src &= 0xBF) & 0x80) == 0) {
			src = GetPage(src);
			dst = GetPage(dst);
			/*page[dst].g.drawImage(page[src].img, 0, 0, 0);*/
			System.arraycopy(page[src].buf, 0, page[dst].buf, 0, page[src].buf.length);
		} else {
			src = GetPage(src & 0x3);
			dst = GetPage(dst);
			if (vscroll >= -199 && vscroll <= 199) {
				int w = page[src].w;
				int h = page[src].h;
				if(vscroll < 0) {
					System.arraycopy(page[src].buf, -vscroll * w, page[dst].buf, 0, (h + vscroll) * w);
				} else {
					System.arraycopy(page[src].buf, 0, page[dst].buf, vscroll * w, (h - vscroll) * w);
				}
				/*page[dst].g.drawImage(page[src].img, h * 160, 0 , 0);*/
				
			}
		}
		
	}
	
	public static void DrawString(String s, int x, int y, int color) {
		/*page[currentPage].g.setColor(pal[color]);
		page[currentPage].g.drawString(s, x, y, 0);*/
	}
	
	private static int CalcStep(int x1, int x2, int dy) {
		return ((x2 - x1) << 16) / ((dy == 0)?1:dy);
	}
	
	public static void DrawPolygon(int color, int zoom, int x, int y, Polygon p) {
		System.err.println("DrawPolygon "+color+" "+zoom+" "+x+" "+y);
		
		/*if(p.w == 0 && p.h == 1 && p.num == 4) {
			DrawPoint(color, x, y);
			return;
		}*/
		
		int x1 = x - p.w / 2;
		int x2 = x + p.w / 2;
		int y1 = y - p.h / 2;
		int y2 = y + p.h / 2;
		
		if(x1 > 319 || x2 < 0 || y1 > 199 || y2 < 0)
			return;
		
		int i = 0;
		int j = p.num - 1;
		
		x2 = p.pointx[i] + x1;
		x1 = p.pointx[j] + x1;
		int hliney = y1;
		
		++i;
		--j;
		
		int cpt1 = x1 << 16;
		int cpt2 = x2 << 16;
		
		while((p.num -= 2) != 0) {
			int h = p.pointy[j] - p.pointy[j + 1];
			int step1 = CalcStep(p.pointx[j + 1], p.pointx[j], h);
			h = p.pointy[j] - p.pointy[i - 1];
			int step2 = CalcStep(p.pointx[i - 1], p.pointx[i], h);
			
			++i;
			--j;
			
			cpt1 = (cpt1 & 0xFFFF0000) | 0x7FFF;
			cpt2 = (cpt2 & 0xFFFF0000) | 0x8000;
			
			if(h == 0) {
				cpt1 += step1;
				cpt2 += step2;
			} else {
				while((h--) != 0) {
					if(hliney >= 0) {
						x1 = cpt1 >>> 16;
						x2 = cpt2 >>> 16;
						if(x1 <= 319 && x2 >= 0) {
							if(x1 < 0)
								x1 = 0;
							if(x2 > 319)
								x2 = 319;
							
							if(color < 0x10)
								DrawLineN(x1, x2, hliney, color);
							else if(color > 0x10)
								DrawLineP(x1, x2, hliney, color);
							else
								DrawLineT(x1, x2, hliney, color);
						}
					}
					
					cpt1 += step1;
					cpt2 += step2;
					
					++hliney;
					if(hliney > 199) {
						//Repaint();
						return;
					}
				}
			}
		}
		
		//Repaint();
	}
	
	/*private static void DrawPoint(int color, int x, int y) {
		if(x >= 0 && x <= 319 && y >= 0 && y <= 199) {
			int off = y * 160 + x / 2;
			
			if(color < 0x10)
				page[paintPage].buf[off] = color;
			else if(color > 0x10)
				page[paintPage].buf[off] = page[0].buf[off];
			else
				page[paintPage].buf[off] |= 0x8;
		}
	}*/
	
	private static void DrawLineT(int x1, int x2, int y, int color) {
		int xmax = Math.max(x1, x2);
		int xmin = Math.min(x1, x2);
		int w = xmax - xmin + 1;
		Page p = page[currentPage];
		
		
		int off = y * p.w + xmin;
		
		System.err.println("DrawLineT "+off+" "+w+" "+color);
		for(int i = off; i < off + w; i++)
			p.buf[i] = pal[(p.buf[i] >>> 24) | 0x8];
	}
	
	private static void DrawLineN(int x1, int x2, int y, int color) {
		int xmax = Math.max(x1, x2);
		int xmin = Math.min(x1, x2);
		int w = xmax - xmin + 1;
		
		Page p = page[currentPage];
		
		int off = y * p.w + xmin;
		
		System.err.println("DrawLineN "+off+" "+w+" "+color);
		for(int i = off; i < off + w; i++)
			p.buf[i] = pal[color];
	}
	
	private static void DrawLineP(int x1, int x2, int y, int color) {
		if(paintPage == 0)
			return;
		
		int xmax = Math.max(x1, x2);
		int xmin = Math.min(x1, x2);
		int w = xmax - xmin + 1;
		
		Page p1 = page[currentPage];
		Page p2 = page[0];
		
		int off = y * p1.w + xmin;
		
		System.err.println("DrawLineP "+off+" "+w+" "+color);
		for(int i = off; i < off + w; i++)
			p1.buf[i] = pal[((p2.buf[i] >>> 24) & color >> 24) & 0xF];
	}
	
	public static void ShowPage(int i, int delayms) {
		try {
		Thread.sleep(delayms);
		} catch(InterruptedException e) {}
		
		if(i == 0xFF) {
			int tmp = paintPage;
			paintPage = tmpPage;
			tmpPage = tmp;
		} else {
			paintPage = GetPage(i);
		}
				
		Repaint();
		
		/*try {
		Thread.sleep(1000);
		} catch(InterruptedException e) {}*/
	}
	
	protected void keyPressed(int k) {
		if(k == -5)
			System.out.println(">>>MARK<<<");
	}

}